/* GCC */
#include <iostream>
#include<cstdio>
#include<cmath>
using namespace std;
int n,p;
int good[81];
int goodc;
struct matrix
{
    long long arr[81][81];
    void operator *=(const matrix& a)
    {
        matrix c;
        for(int i=0;i<81;i++)
            for(int j=0;j<81;j++)
                c.arr[i][j]=0;
        for(int i=0;i<81;i++)
            for(int j=0;j<81;j++)
                {
                    for(int k=0;k<81;k++)
                        c.arr[i][j]=(c.arr[i][j]+arr[k][j]*a.arr[i][k])%p;
                }
        for(int i=0;i<81;i++)
            for(int j=0;j<81;j++)
                arr[i][j]=c.arr[i][j];
    };
};
matrix pow(matrix m,int x)
{
    matrix res;
     for(int i=0;i<81;i++)
            for(int j=0;j<81;j++)
                {
                    if(i==j)
                        res.arr[i][j]=1;
                    else
                        res.arr[i][j]=0;
                }
    while(x)
    {
        if(x%2)
        {
            res*=m;
        }
        m*=m;
        x/=2;
    }
    return res;
}
bool bit(int x,int y)
{
    return (x>>y)&1;
}
bool pr(int x,int y)
{
    if((x/16)!=(y%16))return false;
    if(bit(x,0) && bit(y,5))return false;
    if(bit(x,1) && (bit(y,4)||bit(y,6)))return false;
    if(bit(x,2) && (bit(y,5)||bit(y,7)))return false;
    if(bit(x,3) && bit(y,6))return false;
    return true;
}
matrix M;
int main()
{
    freopen("chess.in","r",stdin);
    freopen("chess.out","w",stdout);
    cin>>n>>p;
    for(int i=0;i<256;i++)
    {
        if(bit(i,0)&&bit(i,6))continue;
        if(bit(i,1)&&bit(i,7))continue;
        if(bit(i,2)&&bit(i,4))continue;
        if(bit(i,3)&&bit(i,5))continue;
        good[goodc++]=i;
    }

    for(int i=0;i<81;i++)
    {
        for(int j=0;j<81;j++)
    {
        if(pr(good[i],good[j]))M.arr[i][j]=1;
    }
    }

    M=pow(M,n-2);
    long long ans=0;
    for(int i=0;i<81;i++)
        for(int j=0;j<81;j++)
    {
        ans=(ans+M.arr[i][j])%p;
    }
    cout<<ans<<endl;
    return 0;
}
